function [output] = activeins(u)
% This block supports the Embedded MATLAB subset.
% See the help menu for details. 

persistent Active_ins;
persistent ins_counter;

%Keep insulin values for the last 10 minutes
if isempty(ins_counter) || ins_counter > 200
    ins_counter = 1;
end

Active_ins(ins_counter) = u;
ins_counter = ins_counter + 1;
insulin = sum(Active_ins);


%Ensure that insulin does not "build up" in the subcutaneous layer
if insulin > 190000
    %If injected insulin over the last ten minutes exceeds limit
    %set insulin injection to zero
    y = 0; 
else
    y = 1;
end
output = y;
end
