Time_insulin_parameters_patient1  = xlsread('Data_patient1.xls','F545:F633');
bolus_insulin_parameters_patient1 = xlsread('Data_patient1.xls','G545:G633');
BG_insulin_parameters_patient1    = xlsread('Data_patient1.xls','H545:H633');
basal_insulin_parameters_patient1 = xlsread('Data_patient1.xls','I545:I633');
Ri_insulin_parameters_patient1    = xlsread('Data_patient1.xls','J545:J633');
Fs_insulin_parameters_patient1    = xlsread('Data_patient1.xls','K545:K633');
Fm_insulin_parameters_patient1    = xlsread('Data_patient1.xls','L545:L633');

%%%%%%%%%%%%%Remove empty samples%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:length(Time_insulin_parameters_patient1)
    if isnan(BG_insulin_parameters_patient1(i)) && i>1
        BG_insulin_parameters_patient1(i) = BG_insulin_parameters_patient1(i-1);
    else if isnan(BG_insulin_parameters_patient1(i)) && i==1
        BG_insulin_parameters_patient1(i) = 7;
        end
    end
end  
for i=1:length(Time_insulin_parameters_patient1)
    if isnan(bolus_insulin_parameters_patient1(i))
        bolus_insulin_parameters_patient1(i) = 0;
    end
end  
for i=1:length(Time_insulin_parameters_patient1)
    if isnan(Ri_insulin_parameters_patient1(i))
        Ri_insulin_parameters_patient1(i) = 0;
    end
end 
for i=1:length(Time_insulin_parameters_patient1)
    if isnan(Fs_insulin_parameters_patient1(i))
        Fs_insulin_parameters_patient1(i) = 0;
    end
end 
for i=1:length(Time_insulin_parameters_patient1)
    if isnan(Fm_insulin_parameters_patient1(i))
        Fm_insulin_parameters_patient1(i) = 0;
    end
end 

for i=1:length(Time_insulin_parameters_patient1)
    if isnan(basal_insulin_parameters_patient1(i))
        basal_insulin_parameters_patient1(i) = 0;
    end
    basal_insulin_parameters_patient1(i) = basal_insulin_parameters_patient1(i)/60;
end

%%%%%%%%%%%%%%%%%%%%Insulin input%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Set insulin input to basal doses plus bolus doses
u_insulin_parameters_patient1 = basal_insulin_parameters_patient1+bolus_insulin_parameters_patient1;

%%%%%%%%%%%%%%%%%%%%%Meal Input:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Create transfer function for filtering the meal ingestion rate
s = tf([1 0], [1]);
A_gm = (16.6/(1.44*135*60)) / ((s+1.44/60)*(s+135/60));
A_sm = (467/(1.61*7.20*7.18*60*60)) / ((s+1.61/60)*(s+7.20/60)*(s+7.18/60));
A_mm = (75.1/(0.466*5.54*5.86*6.43*60*60*60)) / ((s+0.466/60)*(s+5.54/60)*(s+5.86/60)*(s+6.43/60));

T_insulin_parameters_patient1 = 1:370/89:370;

for i=1:length(Time_insulin_parameters_patient1)
    u_gm_insulin_parameters_patient1(i) = (1-Fs_insulin_parameters_patient1(i))*Ri_insulin_parameters_patient1(i);
    u_sm_insulin_parameters_patient1(i) = Fs_insulin_parameters_patient1(i)*(1-Fm_insulin_parameters_patient1(i))*Ri_insulin_parameters_patient1(i);
    u_mm_insulin_parameters_patient1(i) = Fs_insulin_parameters_patient1(i)*Fm_insulin_parameters_patient1(i)*Ri_insulin_parameters_patient1(i);
end

u_gm_insulin_parameters_patient1 = u_gm_insulin_parameters_patient1';
u_sm_insulin_parameters_patient1 = u_sm_insulin_parameters_patient1';
u_mm_insulin_parameters_patient1 = u_mm_insulin_parameters_patient1';

Eg_gm_insulin_parameters_patient1 = lsim(A_gm, u_gm_insulin_parameters_patient1, T_insulin_parameters_patient1);
Eg_sm_insulin_parameters_patient1 = lsim(A_sm, u_sm_insulin_parameters_patient1, T_insulin_parameters_patient1);
Eg_mm_insulin_parameters_patient1 = lsim(A_mm, u_mm_insulin_parameters_patient1, T_insulin_parameters_patient1);

%Setting the meal input by adding the response from the three types of
%starch composition transfer functions
Eg_insulin_parameters_patient1 = Eg_gm_insulin_parameters_patient1 + Eg_mm_insulin_parameters_patient1 + Eg_sm_insulin_parameters_patient1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%adjusting for units on insulin input from U/h to microU/min:
u_insulin_parameters_patient1 = u_insulin_parameters_patient1*1000000/60;

%Setting the total input to a vector containing insulin input(U) and meal
%input (E_g)
u_vector_insulin_parameters_patient1 = [u_insulin_parameters_patient1, Eg_insulin_parameters_patient1];

Time_insulin_parameters_patient1 = Time_insulin_parameters_patient1-661;

%Plotting the inputs and output
figure('Name', 'Data series for estimation og insulin submodel parameters');
subplot(3,1,1), plot(Time_insulin_parameters_patient1, BG_insulin_parameters_patient1) 
xlabel('Time [min]');
title('Blood glucose [mmol/L]');
subplot(3,1,2), plot(Time_insulin_parameters_patient1, u_insulin_parameters_patient1) 
xlabel('Time [min]')
title('Insulin input [\muU/min]');
subplot(3,1,3), plot(Time_insulin_parameters_patient1, Eg_insulin_parameters_patient1) 
xlabel('Time [min]');
title('Meal input [mmol/min]');

