Time_patient1_day1  = xlsread('Data_patient1.xls','F11:F353');
bolus_patient1_day1 = xlsread('Data_patient1.xls','G11:G353');
BG_patient1_day1    = xlsread('Data_patient1.xls','H11:H353');
basal_patient1_day1 = xlsread('Data_patient1.xls','I11:I353');
Ri_patient1_day1    = xlsread('Data_patient1.xls','J11:J353');
Fs_patient1_day1    = xlsread('Data_patient1.xls','K11:K353');
Fm_patient1_day1    = xlsread('Data_patient1.xls','L11:L353');

%%%%%%%%%%%%%Remove empty samples%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:length(Time_patient1_day1)
    if isnan(BG_patient1_day1(i)) && i>1
        BG_patient1_day1(i) = BG_patient1_day1(i-1);
    else if isnan(BG_patient1_day1(i)) && i==1
        BG_patient1_day1(i) = 7;
        end
    end
end  
for i=1:length(Time_patient1_day1)
    if isnan(bolus_patient1_day1(i))
        bolus_patient1_day1(i) = 0;
    end
end
for i=1:length(Time_patient1_day1)
    if isnan(Ri_patient1_day1(i))
        Ri_patient1_day1(i) = 0;
    end
end 
for i=1:length(Time_patient1_day1)
    if isnan(Fs_patient1_day1(i))
        Fs_patient1_day1(i) = 0;
    end
end 
for i=1:length(Time_patient1_day1)
    if isnan(Fm_patient1_day1(i))
        Fm_patient1_day1(i) = 0;
    end
end 

for i=1:length(Time_patient1_day1)
    if isnan(basal_patient1_day1(i))
        basal_patient1_day1(i) = 0;
    end
    basal_patient1_day1(i) = basal_patient1_day1(i)/60;
end

%Insulin input:
%Set insulin input to basal doses plus bolus doses
u_patient1_day1 = basal_patient1_day1+bolus_patient1_day1;

%%%%%%%%%%%%%%%%%%%%%Meal Input:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Create transfer function for filtering the meal ingestion rate
s = tf([1 0], [1]);
A_gm = (16.6/(1.44*135*60)) / ((s+1.44/60)*(s+135/60));
A_sm = (467/(1.61*7.20*7.18*60*60)) / ((s+1.61/60)*(s+7.20/60)*(s+7.18/60));
A_mm = (75.1/(0.466*5.54*5.86*6.43*60*60*60)) / ((s+0.466/60)*(s+5.54/60)*(s+5.86/60)*(s+6.43/60));

T_patient1_day1 = 1:1438/343:1438;

for i=1:length(Time_patient1_day1)
    u_gm_patient1_day1(i) = (1-Fs_patient1_day1(i))*Ri_patient1_day1(i);
    u_sm_patient1_day1(i) = Fs_patient1_day1(i)*(1-Fm_patient1_day1(i))*Ri_patient1_day1(i);
    u_mm_patient1_day1(i) = Fs_patient1_day1(i)*Fm_patient1_day1(i)*Ri_patient1_day1(i);
end

u_gm_patient1_day1 = u_gm_patient1_day1';
u_sm_patient1_day1 = u_sm_patient1_day1';
u_mm_patient1_day1 = u_mm_patient1_day1';

Eg_gm_patient1_day1 = lsim(A_gm, u_gm_patient1_day1, T_patient1_day1);
Eg_sm_patient1_day1 = lsim(A_sm, u_sm_patient1_day1, T_patient1_day1);
Eg_mm_patient1_day1 = lsim(A_mm, u_mm_patient1_day1, T_patient1_day1);

%Setting the meal input by adding the response from the three types of
%starch composition transfer functions
Eg_patient1_day1 = Eg_gm_patient1_day1 + Eg_mm_patient1_day1 + Eg_sm_patient1_day1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%adjusting for units on insulin input from U/h to microU/min:
u_patient1_day1 = u_patient1_day1*1000000/60;  

%Setting the total input to a vector containing insulin input(U) and meal
%input (E_g)
u_vector_patient1_day1 = [u_patient1_day1, Eg_patient1_day1];

%Plotting the inputs and output
figure('Name', 'Patient 1 Day 1');
subplot(3,1,1), plot(Time_patient1_day1, BG_patient1_day1) 
xlabel('Time [min]');
title('Blood glucose patient 1 day 1 [mmol/L]');
subplot(3,1,2), plot(Time_patient1_day1, u_patient1_day1) 
xlabel('Time [min]');
title('Insulin input patient 1 day 1 [mikroU/min]');
subplot(3,1,3), plot(Time_patient1_day1, Eg_patient1_day1) 
xlabel('Time [min]');
title('Meal input patient 1 day 1 [mmol/min]');
