Time_patient1_day3  = xlsread('Data_patient1.xls','F741:F1094');
bolus_patient1_day3 = xlsread('Data_patient1.xls','G741:G1094');
BG_patient1_day3    = xlsread('Data_patient1.xls','H741:H1094');
basal_patient1_day3 = xlsread('Data_patient1.xls','I741:I1094');
Ri_patient1_day3    = xlsread('Data_patient1.xls','J741:J1094');
Fs_patient1_day3    = xlsread('Data_patient1.xls','K741:K1094');
Fm_patient1_day3    = xlsread('Data_patient1.xls','L741:L1094');

%%%%%%%%%%%%%Remove empty samples%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:length(Time_patient1_day3)
    if isnan(BG_patient1_day3(i)) && i>1
        BG_patient1_day3(i) = BG_patient1_day3(i-1);
    else if isnan(BG_patient1_day3(i)) && i==1
        BG_patient1_day3(i) = 7;
        end
    end
end  
for i=1:length(Time_patient1_day3)
    if isnan(bolus_patient1_day3(i))
        bolus_patient1_day3(i) = 0;
    end
end  
for i=1:length(Time_patient1_day3)
    if isnan(Ri_patient1_day3(i))
        Ri_patient1_day3(i) = 0;
    end
end 
for i=1:length(Time_patient1_day3)
    if isnan(Fs_patient1_day3(i))
        Fs_patient1_day3(i) = 0;
    end
end 
for i=1:length(Time_patient1_day3)
    if isnan(Fm_patient1_day3(i))
        Fm_patient1_day3(i) = 0;
    end
end 

for i=1:length(Time_patient1_day3)
    if isnan(basal_patient1_day3(i))
        basal_patient1_day3(i) = 0;
    end
    basal_patient1_day3(i) = basal_patient1_day3(i)/60;
end

%%%%%%%%%%%%%%%%%%%%Insulin input%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Set insulin input to basal doses plus bolus doses
u_patient1_day3 = basal_patient1_day3+bolus_patient1_day3;

%%%%%%%%%%%%%%%%%%%%%Meal Input:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Create transfer function for filtering the meal ingestion rates = tf([1 0], [1]);
A_gm = (16.6/(1.44*135*60)) / ((s+1.44/60)*(s+135/60));
A_sm = (467/(1.61*7.20*7.18*60*60)) / ((s+1.61/60)*(s+7.20/60)*(s+7.18/60));
A_mm = (75.1/(0.466*5.54*5.86*6.43*60*60*60)) / ((s+0.466/60)*(s+5.54/60)*(s+5.86/60)*(s+6.43/60));

T_patient1_day3 = 1:1436/354:1436;

for i=1:length(Time_patient1_day3)
    u_gm_patient1_day3(i) = (1-Fs_patient1_day3(i))*Ri_patient1_day3(i);
    u_sm_patient1_day3(i) = Fs_patient1_day3(i)*(1-Fm_patient1_day3(i))*Ri_patient1_day3(i);
    u_mm_patient1_day3(i) = Fs_patient1_day3(i)*Fm_patient1_day3(i)*Ri_patient1_day3(i);
end

u_gm_patient1_day3 = u_gm_patient1_day3';
u_sm_patient1_day3 = u_sm_patient1_day3';
u_mm_patient1_day3 = u_mm_patient1_day3';

Eg_gm_patient1_day3 = lsim(A_gm, u_gm_patient1_day3, T_patient1_day3);
Eg_sm_patient1_day3 = lsim(A_sm, u_sm_patient1_day3, T_patient1_day3);
Eg_mm_patient1_day3 = lsim(A_mm, u_mm_patient1_day3, T_patient1_day3);

%Setting the meal input by adding the response from the three types of
%starch composition transfer functions
Eg_patient1_day3 = Eg_gm_patient1_day3 + Eg_mm_patient1_day3 + Eg_sm_patient1_day3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%adjusting for units on insulin input from U/h to microU/min:
u_patient1_day3 = u_patient1_day3*1000000/60; 

%Setting the total input to a vector containing insulin input(U) and meal
%input (E_g)
u_vector_patient1_day3 = [u_patient1_day3, Eg_patient1_day3];

%Plotting the inputs and output
figure('Name', 'Patient 1 Day 3');
subplot(3,1,1), plot(Time_patient1_day3, BG_patient1_day3) 
xlabel('Time [min]');
title('Blood glucose patient 1 day 3 [mmol/L]');
subplot(3,1,2), plot(Time_patient1_day3, u_patient1_day3) 
xlabel('Time [min]');
title('Insulin input patient 1 day 3 [mikroU/min]');
subplot(3,1,3), plot(Time_patient1_day3, Eg_patient1_day3) 
xlabel('Time [min]');
title('Meal input patient 1 day 3 [mmol/min]');

