Ts = 0;
z = iddata(BG_insulin_parameters_patient1, u_vector_insulin_parameters_patient1, Ts, 'SamplingInstants', Time_insulin_parameters_patient1, 'Name', 'Blood glucose model');
set(z, 'InputName', {'Insulin dosage', 'Meal glucose contribution'}); 
set(z, 'InputUnit', {'\muU/min', 'mmol/min'});
set(z, 'OutputName', 'Blood glucose', 'OutputUnit', 'mmol/L');
set(z, 'TimeUnit', 'min');

figure('Name', [z.Name ': Data set used for off line estimation: Insulin input -> Blood glucose output']);
plot(z(:, 1, 1));   % Plot input-output pair (Insulin -> Blood glucose).

figure('Name', [z.Name ': Data set used for off line estimation: Meal glucose input -> Blood glucose output']);
plot(z(:, 1, 2));   % Plot input-output pair (Meal -> Blood glucose).


%frequencyplot
figure('Name', 'frequency specter insulin input');
ins_input_u = fft(u_insulin_parameters_patient1);
plot(abs(ins_input_u)) 
xlabel('Frequency [Hz]');
ylabel('Amplitude');
legend('Frequency spectrum insulin input');


figure('Name', 'frequency specter meal input');
ins_input_Eg = fft(Eg_insulin_parameters_patient1);
plot(abs(ins_input_Eg))
xlabel('Frequency [Hz]');
ylabel('Amplitude');
legend('Frequency spectrum meal input');

figure('Name', 'frequency specter blood glucose output');
BG_output= fft(BG_insulin_parameters_patient1);
plot(abs(BG_output)) 
xlabel('Frequency [Hz]');
ylabel('Amplitude');
legend('Frequency spectrum blood glucose output');