%iterate through the measured data of patient 1, and estimate a new K_is
%approxematly every 3rd hour.

%Clear online estimation data vectors to be used
Time_online_patient1 = 0;
BG_online_patient1 = 0;
u_online_patient1 = 0;
Eg_online_patient1 = 0;
u_vector_online_patient1 = 0;
clear Kis_online;

%Initial
initial_BG = 7;

%iteration variables
j = 1;
i = 1;

%
while (i+50)<=length(Time_tot_patient1)
    l = 1;
    %Consider 50 samples at a time = 50*5 = 250 min = 4,16 h
    for k=i:i+50
        Time_online_patient1(l) = Time_tot_patient1(k);
        BG_online_patient1(l)   = BG_tot_patient1(k);
        u_online_patient1(l)    = u_tot_patient1(k);
        Eg_online_patient1(l)   = Eg_tot_patient1(k);
        l = l+1;
    end
    %convert to column vector
    Time_online_patient1 = Time_online_patient1';
    BG_online_patient1   = BG_online_patient1';
    u_online_patient1 = u_online_patient1';
    Eg_online_patient1 = Eg_online_patient1';
    
    %set u_vector (for input to iddata_online_patient1.m),
    %and estimate K_is.
    u_vector_online_patient1 = [u_online_patient1, Eg_online_patient1];
    iddata_online_patient1;
    identify_online;
    
    %Save the estimated value of K_is
    Kis_online(j) = getpar(themodel)
    
    %Set initial blood glucose to the last value of this data set.
    initial_BG = BG_online_patient1(l-1);
    
    %update iteration variables
    j = j+1;
    i = i+5;
   
    %Set all online estimation vectors to zero before next iteration
    Time_online_patient1 = 0;
    BG_online_patient1 = 0;
    u_online_patient1 = 0;
    Eg_online_patient1 = 0;
    u_vector_online_patient1 = 0;
end

clear K_is;
Time_tot_updated_model_patient1 = 0;
BG_tot_updated_model_patient1 = 0;
u_tot_updated_model_patient1 = 0;
Eg_tot_updated_model_patient1 = 0;
    
%convert online updated parameter from cell to number
j = 1;
i = 1;
while j<=length(Kis_online)
    K_is_analysis(j) = cell2num(Kis_online(j));
    for i=i:i+5
        K_is_patient1(i) = cell2num(Kis_online(j));
    end  
j = j+1;  
end

for l=1:length(K_is_patient1)
    if K_is_patient1(l)<=0
        K_is_patient1(l) = 0.0005;
    end
end

for l=1:length(K_is_analysis)
    if K_is_analysis(l)<=0
        K_is_analysis(l) = 0.0005;
    end
end

%time vector for the total estimation interval
Time_tot_updated_model_patient1 =Time_tot_patient1(1:length(K_is_patient1));
%Output vector for the total estimation interval
BG_tot_updated_model_patient1 = BG_tot_patient1(1:length(K_is_patient1));
%Input vectors for the total estimateion interval
u_tot_updated_model_patient1 = u_tot_patient1(1:length(K_is_patient1));
Eg_tot_updated_model_patient1 = Eg_tot_patient1(1:length(K_is_patient1));

u_vector_tot_updated_model_patient1 = [u_tot_updated_model_patient1, Eg_tot_updated_model_patient1];

K_is_patient1 = K_is_patient1'
figure('Name', 'Estimated K_is for patient 1');
plot(Time_tot_updated_model_patient1, K_is_patient1)
xlabel('Time [min]');
ylabel('K_{is}');
title('Estimated K_{is} for patient 1');

%u_vector_updated_model_patient1 = [u_tot_updated_model_patient1,
%Eg_tot_updated_model_patient1, K_is_patient1];

clear K_is_patient2;
Time_tot_updated_model_patient2 = 0;
BG_tot_updated_model_patient2 = 0;
u_tot_updated_model_patient2 = 0;
Eg_tot_updated_model_patient2 = 0;

    %Constant parameters
    V_G = 9.91;
    T_i = 0.152*60;
    T_YG = 0.194*60; 
    T_GY = 0.194*60;
    K_YG = 0.952;
  
    %Patient specific parameters found by off line estimation (see
    %identify_insulin_parameters.m):
    
    %Parameters for patient 2
    T_xi = 115.8;
    T_m = 133.9;
    K_i = 0.0233;

%convert online updated parameter from cell to number
j = 1;
i = 1;
while j<=length(Kis_online_patient2)
    K_is_analysis(j) = cell2num(Kis_online_patient2(j));
    for i=i:i+5
        K_is_patient2(i) = cell2num(Kis_online_patient2(j));
    end
j = j+1;  
end

for l=1:length(K_is_patient2)
    if K_is_patient2(l)<=0
        K_is_patient2(l) = 0;
    end
end


for l=1:length(K_is_analysis)
    if K_is_analysis(l)<=0
        K_is_analysis(l) = 0;
    end
end


for i=1:length(Kis_online_patient2)
    Kis_smooth(i) = cell2num(Kis_online_patient2(i));
end

%time vector for the total estimation interval
Time_tot_updated_model_patient2 =Time_tot_patient2(1:length(K_is_patient2));
%Output vector for the total estimation interval
BG_tot_updated_model_patient2 = BG_tot_patient2(1:length(K_is_patient2));
%Input vectors for the total estimateion interval
u_tot_updated_model_patient2 = u_tot_patient2(1:length(K_is_patient2));
Eg_tot_updated_model_patient2 = Eg_tot_patient2(1:length(K_is_patient2));

u_vector_tot_updated_model_patient2 = [u_tot_updated_model_patient2, Eg_tot_updated_model_patient2];

K_is_patient2 = K_is_patient2'
figure('Name', 'Estimated K_is for patient 2');
plot(Time_tot_updated_model_patient2, K_is_patient2)
xlabel('Time [min]');
ylabel('K_{is}');
title('Estimated K_{is} for patient 2');

