Time_insulin_parameters_patient2  = xlsread('Data_patient2.xls','F854:F959');
bolus_insulin_parameters_patient2 = xlsread('Data_patient2.xls','G854:G959');
BG_insulin_parameters_patient2    = xlsread('Data_patient2.xls','H854:H959');
basal_insulin_parameters_patient2 = xlsread('Data_patient2.xls','I854:I959');
Ri_insulin_parameters_patient2    = xlsread('Data_patient2.xls','J854:J959');
Fs_insulin_parameters_patient2    = xlsread('Data_patient2.xls','K854:K959');
Fm_insulin_parameters_patient2    = xlsread('Data_patient2.xls','L854:L959');

%%%%%%%%%%%%%Remove empty samples%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:length(Time_insulin_parameters_patient2)
    if isnan(BG_insulin_parameters_patient2(i)) && i>1
        BG_insulin_parameters_patient2(i) = BG_insulin_parameters_patient2(i-1);
    else if isnan(BG_insulin_parameters_patient2(i)) && i==1
        BG_insulin_parameters_patient2(i) = 7;
        end
    end
end  
for i=1:length(Time_insulin_parameters_patient2)
    if isnan(bolus_insulin_parameters_patient2(i))
        bolus_insulin_parameters_patient2(i) = 0;
    end
end  
for i=1:length(Time_insulin_parameters_patient2)
    if isnan(Ri_insulin_parameters_patient2(i))
        Ri_insulin_parameters_patient2(i) = 0;
    end
end 
for i=1:length(Time_insulin_parameters_patient2)
    if isnan(Fs_insulin_parameters_patient2(i))
        Fs_insulin_parameters_patient2(i) = 0;
    end
end 
for i=1:length(Time_insulin_parameters_patient2)
    if isnan(Fm_insulin_parameters_patient2(i))
        Fm_insulin_parameters_patient2(i) = 0;
    end
end 

for i=1:length(Time_insulin_parameters_patient2)
    if isnan(basal_insulin_parameters_patient2(i))
        basal_insulin_parameters_patient2(i) = 0;
    end
    basal_insulin_parameters_patient2(i) = basal_insulin_parameters_patient2(i)/60;
end

%%%%%%%%%%%%%%%%%%%%Insulin input%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Set insulin input to basal doses plus bolus doses
u_insulin_parameters_patient2 = basal_insulin_parameters_patient2+bolus_insulin_parameters_patient2;

%%%%%%%%%%%%%%%%%%%%%Meal Input:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Create transfer function for filtering the meal ingestion rate
s = tf([1 0], [1]);
A_gm = (16.6/(1.44*135*60)) / ((s+1.44/60)*(s+135/60));
A_sm = (467/(1.61*7.20*7.18*60*60)) / ((s+1.61/60)*(s+7.20/60)*(s+7.18/60));
A_mm = (75.1/(0.466*5.54*5.86*6.43*60*60*60)) / ((s+0.466/60)*(s+5.54/60)*(s+5.86/60)*(s+6.43/60));

T_insulin_parameters_patient2 = 1:415/106:415;

for i=1:length(Time_insulin_parameters_patient2)
    u_gm_insulin_parameters_patient2(i) = (1-Fs_insulin_parameters_patient2(i))*Ri_insulin_parameters_patient2(i);
    u_sm_insulin_parameters_patient2(i) = Fs_insulin_parameters_patient2(i)*(1-Fm_insulin_parameters_patient2(i))*Ri_insulin_parameters_patient2(i);
    u_mm_insulin_parameters_patient2(i) = Fs_insulin_parameters_patient2(i)*Fm_insulin_parameters_patient2(i)*Ri_insulin_parameters_patient2(i);
end

u_gm_insulin_parameters_patient2 = u_gm_insulin_parameters_patient2';
u_sm_insulin_parameters_patient2 = u_sm_insulin_parameters_patient2';
u_mm_insulin_parameters_patient2 = u_mm_insulin_parameters_patient2';

Eg_gm_insulin_parameters_patient2 = lsim(A_gm, u_gm_insulin_parameters_patient2, T_insulin_parameters_patient2);
Eg_sm_insulin_parameters_patient2 = lsim(A_sm, u_sm_insulin_parameters_patient2, T_insulin_parameters_patient2);
Eg_mm_insulin_parameters_patient2 = lsim(A_mm, u_mm_insulin_parameters_patient2, T_insulin_parameters_patient2);

%Setting the meal input by adding the response from the three types of
%starch composition transfer functions
Eg_insulin_parameters_patient2 = Eg_gm_insulin_parameters_patient2 + Eg_mm_insulin_parameters_patient2 + Eg_sm_insulin_parameters_patient2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%adjusting for units on insulin input from U/h to microU/min:
u_insulin_parameters_patient2 = u_insulin_parameters_patient2*1000000/60;

%Setting the total input to a vector containing insulin input(U) and meal
%input (E_g)
u_vector_insulin_parameters_patient2 = [u_insulin_parameters_patient2, Eg_insulin_parameters_patient2];

Time_insulin_parameters_patient2 = Time_insulin_parameters_patient2-661;

%Plotting the inputs and output
figure('Name', 'Data series for estimation og insulin submodel parameters');
subplot(3,1,1), plot(Time_insulin_parameters_patient2, BG_insulin_parameters_patient2) 
xlabel('Time [min]');
title('Blood glucose [mmol/L]');
subplot(3,1,2), plot(Time_insulin_parameters_patient2, u_insulin_parameters_patient2) 
xlabel('Time [min]')
title('Insulin input [\muU/min]');
subplot(3,1,3), plot(Time_insulin_parameters_patient2, Eg_insulin_parameters_patient2) 
xlabel('Time [min]');
title('Meal input [mmol/min]');

