Time_patient2_day3  = xlsread('Data_patient2.xls','F960:F1215');
bolus_patient2_day3 = xlsread('Data_patient2.xls','G960:G1215');
BG_patient2_day3    = xlsread('Data_patient2.xls','H960:H1215');
basal_patient2_day3 = xlsread('Data_patient2.xls','I960:I1215');
Ri_patient2_day3    = xlsread('Data_patient2.xls','J960:J1215');
Fs_patient2_day3    = xlsread('Data_patient2.xls','K960:K1215');
Fm_patient2_day3    = xlsread('Data_patient2.xls','L960:L1215');

%%%%%%%%%%%%%Remove empty samples%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:length(Time_patient2_day3)
    if isnan(BG_patient2_day3(i)) && i>1
        BG_patient2_day3(i) = BG_patient2_day3(i-1);
    else if isnan(BG_patient2_day3(i)) && i==1
        BG_patient2_day3(i) = 7;
        end
    end
end  
for i=1:length(Time_patient2_day3)
    if isnan(bolus_patient2_day3(i))
        bolus_patient2_day3(i) = 0;
    end
end  
for i=1:length(Time_patient2_day3)
    if isnan(Ri_patient2_day3(i))
        Ri_patient2_day3(i) = 0;
    end
end 
for i=1:length(Time_patient2_day3)
    if isnan(Fs_patient2_day3(i))
        Fs_patient2_day3(i) = 0;
    end
end 
for i=1:length(Time_patient2_day3)
    if isnan(Fm_patient2_day3(i))
        Fm_patient2_day3(i) = 0;
    end
end 

for i=1:length(Time_patient2_day3)
    if isnan(basal_patient2_day3(i))
        basal_patient2_day3(i) = 0;
    end
end

%%%%%%%%%%%%%%%%%%%%Insulin input%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Set insulin input to basal doses plus bolus doses
u_patient2_day3 = basal_patient2_day3+bolus_patient2_day3;

%%%%%%%%%%%%%%%%%%%%%Meal Input:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Create transfer function for filtering the meal ingestion rate
s = tf([1 0], [1]);
A_gm = (16.6/(1.44*135*60)) / ((s+1.44/60)*(s+135/60));
A_sm = (467/(1.61*7.20*7.18*60*60)) / ((s+1.61/60)*(s+7.20/60)*(s+7.18/60));
A_mm = (75.1/(0.466*5.54*5.86*6.43*60*60*60)) / ((s+0.466/60)*(s+5.54/60)*(s+5.86/60)*(s+6.43/60));

%T_patient2_day3 = 1:1439/291:1439;
T_patient2_day3 = 1:1106/256:1106;

for i=1:length(Time_patient2_day3)
    u_gm_patient2_day3(i) = (1-Fs_patient2_day3(i))*Ri_patient2_day3(i);
    u_sm_patient2_day3(i) = Fs_patient2_day3(i)*(1-Fm_patient2_day3(i))*Ri_patient2_day3(i);
    u_mm_patient2_day3(i) = Fs_patient2_day3(i)*Fm_patient2_day3(i)*Ri_patient2_day3(i);
end

u_gm_patient2_day3 = u_gm_patient2_day3';
u_sm_patient2_day3 = u_sm_patient2_day3';
u_mm_patient2_day3 = u_mm_patient2_day3';

Eg_gm_patient2_day3 = lsim(A_gm, u_gm_patient2_day3, T_patient2_day3);
Eg_sm_patient2_day3 = lsim(A_sm, u_sm_patient2_day3, T_patient2_day3);
Eg_mm_patient2_day3 = lsim(A_mm, u_mm_patient2_day3, T_patient2_day3);

%adjusting for units on insulin input from U/h to microU/min:
u_patient2_day3 = u_patient2_day3*1000000/60; 

%Setting the meal input by adding the response from the three types of
%starch composition transfer functions
Eg_patient2_day3 = Eg_gm_patient2_day3 + Eg_mm_patient2_day3 + Eg_sm_patient2_day3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Setting the total input to a vector containing insulin input(U) and meal
u_vector_patient2_day3 = [u_patient2_day3, Eg_patient2_day3];

%Plotting the inputs and output
figure('Name', 'Patient 2 Day 3');
subplot(3,1,1), plot(Time_patient2_day3, BG_patient2_day3) 
xlabel('Time [min]');
title('Blood glucose patient 2 day 3 [mmol/L]');
subplot(3,1,2), plot(Time_patient2_day3, u_patient2_day3) 
xlabel('Time [min]');
title('Insulin input patient 2 day 3 [\muU/min]');
subplot(3,1,3), plot(Time_patient2_day3, Eg_patient2_day3) 
xlabel('Time [min]');
title('Meal input patient 2 day 3 [mmol/min]');
