Time_patient2_day4  = xlsread('Data_patient2.xls','F1301:F1438');
bolus_patient2_day4 = xlsread('Data_patient2.xls','G1301:G1438');
BG_patient2_day4    = xlsread('Data_patient2.xls','H1301:H1438');
basal_patient2_day4 = xlsread('Data_patient2.xls','I1301:I1438');
Ri_patient2_day4    = xlsread('Data_patient2.xls','J1301:J1438');
Fs_patient2_day4    = xlsread('Data_patient2.xls','K1301:K1438');
Fm_patient2_day4    = xlsread('Data_patient2.xls','L1301:L1438');

%%%%%%%%%%%%%Remove empty samples%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:length(Time_patient2_day4)
    if isnan(BG_patient2_day4(i)) && i>1
        BG_patient2_day4(i) = BG_patient2_day4(i-1);
    else if isnan(BG_patient2_day4(i)) && i==1
        BG_patient2_day4(i) = 7;
        end
    end
end  
for i=1:length(Time_patient2_day4)
    if isnan(bolus_patient2_day4(i))
        bolus_patient2_day4(i) = 0;
    end
end

%for i=1:length(Time_patient2_day4)
%    if isnan(Ri_patient2_day4(i))
%        Ri_patient2_day4(i) = 0;
%    end
%end 
%for i=1:length(Time_patient2_day4)
%    if isnan(Fs_patient2_day4(i))
%        Fs_patient2_day4(i) = 0;
%    end
%end 
%for i=1:length(Time_patient2_day4)
%    if isnan(Fm_patient2_day4(i))
%        Fm_patient2_day4(i) = 0;
%    end
%end 

for i=1:length(Time_patient2_day4)
    if isnan(basal_patient2_day4(i))
        basal_patient2_day4(i) = 0;
    end
end

figure('Name', 'Patient 2 Day 4');
subplot(3,1,1), plot(Time_patient2_day4, Fs_patient2_day4) 
xlabel('Time [min]');
title('Fm 2 day 4 [mmol/L]');
subplot(3,1,2), plot(Time_patient2_day4, Fm_patient2_day4) 
xlabel('Time [min]');
title('Fm 2 day 4 [\muU/min]');
subplot(3,1,3), plot(Time_patient2_day4, Ri_patient2_day4) 
xlabel('Time [min]');
title('Ri 2 day 4 [mmol/min]');

%%%%%%%%%%%%%%%%%%%%Insulin input%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Set insulin input to basal doses plus bolus doses
u_patient2_day4 = basal_patient2_day4+bolus_patient2_day4;

%%%%%%%%%%%%%%%%%%%%%Meal Input:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Create transfer function for filtering the meal ingestion rates 
s = tf([1 0], [1]);
A_gm = (16.6/(1.44*135*60)) / ((s+1.44/60)*(s+135/60));
A_sm = (467/(1.61*7.20*7.18*60*60)) / ((s+1.61/60)*(s+7.20/60)*(s+7.18/60));
A_mm = (75.1/(0.466*5.54*5.86*6.43*60*60*60)) / ((s+0.466/60)*(s+5.54/60)*(s+5.86/60)*(s+6.43/60));

T_patient2_day4 = 585:((1435-585)/137):1435;

for i=1:length(Time_patient2_day4)
    u_gm_patient2_day4(i) = (1-Fs_patient2_day4(i))*Ri_patient2_day4(i);
    u_sm_patient2_day4(i) = Fs_patient2_day4(i)*(1-Fm_patient2_day4(i))*Ri_patient2_day4(i);
    u_mm_patient2_day4(i) = Fs_patient2_day4(i)*Fm_patient2_day4(i)*Ri_patient2_day4(i);
end


u_gm_patient2_day4 = u_gm_patient2_day4';
u_sm_patient2_day4 = u_sm_patient2_day4';
u_mm_patient2_day4 = u_mm_patient2_day4';

Eg_gm_patient2_day4 = lsim(A_gm, u_gm_patient2_day4, T_patient2_day4);
Eg_sm_patient2_day4 = lsim(A_sm, u_sm_patient2_day4, T_patient2_day4);
Eg_mm_patient2_day4 = lsim(A_mm, u_mm_patient2_day4, T_patient2_day4);

%Setting the meal input by adding the response from the three types of
%starch composition transfer functions
Eg_patient2_day4 = Eg_gm_patient2_day4 + Eg_mm_patient2_day4 + Eg_sm_patient2_day4;
Eg_patient2_day4 = Eg_patient2_day4*2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%adjusting for units on insulin input from U/h to microU/min:
u_patient2_day4 = u_patient2_day4*1000000/60; 

%Setting the total input to a vector containing insulin input(U) and meal
u_vector_patient2_day4 = [u_patient2_day4, Eg_patient2_day4];

%Plotting the inputs and output
figure('Name', 'Patient 2 Day 4');
subplot(3,1,1), plot(Time_patient2_day4, BG_patient2_day4) 
xlabel('Time [min]');
ylabel('Y(t) [mmol/L]');
title('Blood glucose patient 2 day 4 [mmol/L]');
subplot(3,1,2), plot(Time_patient2_day4, u_patient2_day4) 
xlabel('Time [min]');
ylabel('U(t) [\muU/min]');
title('Insulin input patient 2 day 4 [\muU/min]');
subplot(3,1,3), plot(Time_patient2_day4, Eg_patient2_day4) 
xlabel('Time [min]');
ylabel('E_g(t) [mmol/min]');
title('Meal input patient 2 day 4 [mmol/min]');
