Time_patient3_day2  = xlsread('Data_patient3.xls','F341:F682');
bolus_patient3_day2 = xlsread('Data_patient3.xls','G341:G682');
BG_patient3_day2    = xlsread('Data_patient3.xls','H341:H682');
basal_patient3_day2 = xlsread('Data_patient3.xls','I341:I682');
Ri_patient3_day2    = xlsread('Data_patient3.xls','J341:J682');
Fs_patient3_day2    = xlsread('Data_patient3.xls','K341:K682');
Fm_patient3_day2    = xlsread('Data_patient3.xls','L341:L682');

%%%%%%%%%%%%%Remove empty samples%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:length(Time_patient3_day2)
    if isnan(BG_patient3_day2(i)) && i>1
        BG_patient3_day2(i) = BG_patient3_day2(i-1);
    else if isnan(BG_patient3_day2(i)) && i==1
        BG_patient3_day2(i) = 7;
        end
    end
end  
for i=1:length(Time_patient3_day2)
    if isnan(bolus_patient3_day2(i))
        bolus_patient3_day2(i) = 0;
    end
end  
for i=1:length(Time_patient3_day2)
    if isnan(Ri_patient3_day2(i))
        Ri_patient3_day2(i) = 0;
    end
end 
for i=1:length(Time_patient3_day2)
    if isnan(Fs_patient3_day2(i))
        Fs_patient3_day2(i) = 0;
    end
end 
for i=1:length(Time_patient3_day2)
    if isnan(Fm_patient3_day2(i))
        Fm_patient3_day2(i) = 0;
    end
end 

for i=1:length(Time_patient3_day2)
    if isnan(basal_patient3_day2(i))
        basal_patient3_day2(i) = 0;
    end
end

%%%%%%%%%%%%%%%%%%%%Insulin input%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Set insulin input to basal doses plus bolus doses
u_patient3_day2 = basal_patient3_day2+bolus_patient3_day2;

%%%%%%%%%%%%%%%%%%%%%Meal Input:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Create transfer function for filtering the meal ingestion rate
s = tf([1 0], [1]);
A_gm = (16.6/(1.44*135*60)) / ((s+1.44/60)*(s+135/60));
A_sm = (467/(1.61*7.20*7.18*60*60)) / ((s+1.61/60)*(s+7.20/60)*(s+7.18/60));
A_mm = (75.1/(0.466*5.54*5.86*6.43*60*60*60)) / ((s+0.466/60)*(s+5.54/60)*(s+5.86/60)*(s+6.43/60));

T_patient3_day2 = 1:1435/342:1435;

for i=1:length(Time_patient3_day2)
    u_gm_patient3_day2(i) = (1-Fs_patient3_day2(i))*Ri_patient3_day2(i);
    u_sm_patient3_day2(i) = Fs_patient3_day2(i)*(1-Fm_patient3_day2(i))*Ri_patient3_day2(i);
    u_mm_patient3_day2(i) = Fs_patient3_day2(i)*Fm_patient3_day2(i)*Ri_patient3_day2(i);
end

u_gm_patient3_day2 = u_gm_patient3_day2';
u_sm_patient3_day2 = u_sm_patient3_day2';
u_mm_patient3_day2 = u_mm_patient3_day2';

Eg_gmpatient3_day2 = lsim(A_gm, u_gm_patient3_day2, T_patient3_day2);
Eg_smpatient3_day2 = lsim(A_sm, u_sm_patient3_day2, T_patient3_day2);
Eg_mmpatient3_day2 = lsim(A_mm, u_mm_patient3_day2, T_patient3_day2);

%Setting the meal input by adding the response from the three types of
%starch composition transfer functions
Eg_patient3_day2 = Eg_gmpatient3_day2 + Eg_mmpatient3_day2 + Eg_smpatient3_day2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%adjusting for units on insulin input from U/h to microU/min:
u_patient3_day2 = u_patient3_day2*1000000/60; 

%Setting the total input to a vector containing insulin input(U) and meal
%input (E_g)
u_vector_patient3_day2 = [u_patient3_day2, Eg_patient3_day2];

%Plotting the inputs and output
figure('Name', 'Patient 3 Day 2');
subplot(3,1,1), plot(Time_patient3_day2, BG_patient3_day2) 
xlabel('Time [min]');
title('Blood glucose patient 3 day 2 [mmol/L]');
subplot(3,1,2), plot(Time_patient3_day2, u_patient3_day2) 
xlabel('Time [min]');
title('Insulin input patient 3 day 2 [\muU/min]');
subplot(3,1,3), plot(Time_patient3_day2, Eg_patient3_day2) 
xlabel('Time [min]');
title('Meal input patient 3 day 2 [mmol/min]');

