    %Model of glucose - insulin - homeostasis
    %This function is input to the system identification in identify_insulin_parameters.m
    
function [dx, y] = glucose_online_m(t, x, u, K_is, varargin)
   
    %Constant parameters
    V_G = 9.91;
    T_i = 0.152*60;
    T_YG = 0.194*60; 
    T_GY = 0.194*60;
    K_YG = 0.952;
  
    %Patient specific parameters found by off line estimation (see
    %identify_insulin_parameters.m):
    
    %Parameters for patient 1
    %T_xi = 108.6;
    %T_m = 147.0;
    %K_i = 0.0202;
    
    %Parameters for patient 2
    %T_xi = 115.8;
    %T_m = 133.9;
    %K_i = 0.0233;
    
    %Parameters for patient 3
    T_xi = 106.0;
    T_m = 149.4;
    K_i = 3.997;
    
   %%%%%%%%%%%%%%%%%%%%%Output equations%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    y = [x(5)];
   
    %%%%%%%%%%%%%%%%%%%%%%State equations%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

     if (840/x(2))/60 - 10/60 > 52.6/60
        Q_r = 52.6/60;
     elseif 52.6/60 >= 840/x(2)/60 - 10/60 >= 0
        Q_r = (840/x(2))/60 - 10/60;
     else
        Q_r = 0;
     end

     if (3.64*x(4))/60 - 15/60 >= 14/60
        Q_g = (3.64*x(4))/60 - 15/60;
     else
        Q_g = 14/60;
     end 
     
     E_b = Q_r - 0.25*u(2) - Q_g;

     E_m = 0.117*(0.87+tanh(0.0045*(x(4)-175)));
     if E_m >= 0
         E_r = E_m/60;
     else
         E_r = 0;
     end
     
    dx = [(1/T_i)*(-x(1) + u(1));
          (1/T_xi)*(-x(2) + K_i*x(1)); 
          (1/T_m)*(-x(3) + x(2)); 
          -x(4)/T_YG + x(5)/T_GY + 1/V_G*(u(2)+E_b)-E_r;
          K_YG*(x(4)/T_YG - x(5)/T_GY) - K_is*x(3)*x(5);
          ];
     
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 


      
      
              