%iterate through the measured data of patient 1, and estimate a new K_is
%approxematly every 3rd hour.

%Clear online estimation data vectors to be used
Time_online_patient3 = 0;
BG_online_patient3 = 0;
u_online_patient3 = 0;
Eg_online_patient3 = 0;
u_vector_online_patient3 = 0;
clear Kis_online;

%Initial
initial_BG = BG_tot_patient3(1);

%iteration variables
j = 1;
i = 1;

%
while (i+50)<=length(Time_tot_patient3)
    l = 1;
    %Consider 50 samples at a time = 50*5 = 250 min = 4,16 h
    for k=i:i+50
        Time_online_patient3(l) = Time_tot_patient3(k);
        BG_online_patient3(l)   = BG_tot_patient3(k);
        u_online_patient3(l)    = u_tot_patient3(k);
        Eg_online_patient3(l)   = Eg_tot_patient3(k);
        l = l+1;
    end
    %convert to column vector
    Time_online_patient3 = Time_online_patient3';
    BG_online_patient3   = BG_online_patient3';
    u_online_patient3 = u_online_patient3';
    Eg_online_patient3 = Eg_online_patient3';
    
    %set u_vector (for input to iddata_online_patient3.m),
    %and estimate K_is.
    u_vector_online_patient3 = [u_online_patient3, Eg_online_patient3];
    iddata_online_patient3;
    identify_online;
    
    %Save the estimated value of K_is
    Kis_online_patient3(j) = getpar(themodel)
    
    %Set initial blood glucose to the last value of this data set.
    initial_BG = BG_online_patient3(l-1);
    
    %update iteration variables
    j = j+1;
    i = i+5;
    
    %Set all online estimation vectors to zero before next iteration
    Time_online_patient3 = 0;
    BG_online_patient3 = 0;
    u_online_patient3 = 0;
    Eg_online_patient3 = 0;
    u_vector_online_patient3 = 0;
end

clear K_is_patient2;
Time_tot_updated_model_patient3 = 0;
BG_tot_updated_model_patient3 = 0;
u_tot_updated_model_patient3 = 0;
Eg_tot_updated_model_patient3 = 0;

%convert online updated parameter from cell to number
j = 1;
i = 1;
while j<=length(Kis_online_patient3)
    K_is_analysis(j) = cell2num(Kis_online_patient3(j));
    for i=i:i+5
        K_is_patient3(i) = cell2num(Kis_online_patient3(j));
    end
j = j+1;  
end

for l=1:length(K_is_patient3)
    if K_is_patient3(l)<=0
        K_is_patient3(l) = 0.0002;
    end
    if K_is_patient3(l)>0.002
        K_is_patient3(l) = 0.002;
    end
end

for i=1:length(Kis_online_patient3)
    Kis_smooth(i) = cell2num(Kis_online_patient3(i));
end

for l=1:length(K_is_analysis)
    if K_is_analysis(l)<=0
        K_is_analysis(l) = 0.0010;
    end
end


%time vector for the total estimation interval
Time_tot_updated_model_patient3 =Time_tot_patient3(1:length(K_is_patient3));
%Output vector for the total estimation interval
BG_tot_updated_model_patient3 = BG_tot_patient3(1:length(K_is_patient3));
%Input vectors for the total estimateion interval
u_tot_updated_model_patient3 = u_tot_patient3(1:length(K_is_patient3));
Eg_tot_updated_model_patient3 = Eg_tot_patient3(1:length(K_is_patient3));

K_is_patient3 = K_is_patient3'
figure('Name', 'Estimated K_is for patient 3');
plot(Time_tot_updated_model_patient3, K_is_patient3)
xlabel('Time [min]');
title('Estimated K_{is} for patient 3');

u_vector_tot_updated_model_patient3 = [u_tot_updated_model_patient3, Eg_tot_updated_model_patient3];
