%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%Load data from excel sheet to matlab workspace%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Data from glucose monitor and insulin pump for patient 1
run Patient1/excel2matlab_patient1_day1;
run Patient1/excel2matlab_patient1_day2;
run Patient1/excel2matlab_patient1_day3;
run Patient1/excel2matlab_patient1_day4;

%Data from glucose monitor and insulin pump for patient 2
run Patient2/excel2matlab_patient2_day1;
run Patient2/excel2matlab_patient2_day2;
run Patient2/excel2matlab_patient2_day3;
run Patient2/excel2matlab_patient2_day4;

%Data from glucose monitor and insulin pump for patient 3
run Patient3/excel2matlab_patient3_day1;
run Patient3/excel2matlab_patient3_day2;

%Connect data for the whole test period for each patient

%run Patient1/total_period_patient1;
%run Patient2/total_period_patient2;
run Patient3/total_period_patient3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%SYSTEM IDENTIFICATION%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%create IDDATA_object%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%The iddata object is used as input to the grey box modeling. 
%Choose one of the iddata object m-files under to generate input to the system
%identification
%run Patient1/iddata_patient1_day1;
%run Patient1/iddata_patient1_day2;
%run Patient1/iddata_patient1_day3;
%run Patient1/iddata_patient1_day4;
%run Patient2/iddata_patient2_day1;
%run Patient2/iddata_patient2_day2;
%run Patient2/iddata_patient2_day3;
%run Patient2/iddata_patient2_day4;
%run Patient3/iddata_patient3_day1;
%run Patient3/iddata_patient3_day2;
%run Patient1/iddata_total_period_patient1
%run Patient2/iddata_total_period_patient2
%run Patient3/iddata_total_period_patient3

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%Grey box modeling%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%Insulin submodel%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Identifying the insulin submodel parameters (T_xi, T_m and K_i) off line. 
%This is done for each patient before the control algorithm is implemented. 
%The parameters found here will be set as non-changing constants during control later.

%load data series with persistently exciting signal to identify the
%parameters of the insulin submodel

%Patient 1
%run Patient1/excel2matlab_insulin_parameters_patient1;
%run Patient1/iddata_insulin_parameters_patient1;

%Patient 2
%run Patient2/excel2matlab_insulin_parameters_patient2;
%run Patient2/iddata_insulin_parameters_patient2;

%Patient 3
%run Patient3/excel2matlab_insulin_parameters_patient3;
%run Patient3/iddata_insulin_parameters_patient3;

%identify_insulin_parameters;

%%%%%%%%%%%%%%%%%%%%%%%%Identifying insulin sensitivity (K_is)%%%%%%%%%%%%%
%After the paramters in the insulin submodel has been identified for the
%individual patient, the insulin sensivity parameter K_is must be estimated
%online.

%identify_online;

